/* adv_wireless.js - API library for Advanced Wireless configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT10,mvb  written. 
*/


function radioValidate ()
	{
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtBeconInt,Please enter a valid Beacon Interval";
    txtFieldIdArr[1] = " ,Please enter a valid Dtim Interval";
    txtFieldIdArr[2] = "txtRTSThld,Please enter a valid RTS Threshold";
    txtFieldIdArr[3] = "txtFgmThld,Please enter a valid Fragmentation Threshold";
    txtFieldIdArr[4] = "txtTrmPwrGain,Please enter a valid Transmit Power Gain";
    txtFieldIdArr[5] = "txtShortRetryLmit,Please enter a valid Short Retry Limit";
    txtFieldIdArr[6] = "txtLongRetryLmit,Please enter a valid Long Retry Limit";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
	var myObj = document.getElementById ('txtBeconInt');
	if (numericValueRangeCheck (myObj, '', '', 40, 3500, true, '', 'Milliseconds') == false)
		return false;
		
	myObj = document.getElementById ('txtDtimInt');
	if (numericValueRangeCheck (myObj, '', '', 1, 255, true, '', 'Milliseconds') == false)
		return false;

	myObj = document.getElementById ('txtRTSThld');
	if (numericValueRangeCheck (myObj, '', '', 256, 2346, true, '', 'Bytes') == false)
		return false;

	myObj = document.getElementById ('txtFgmThld');
	if (numericValueRangeCheck (myObj, '', '', 257, 2346, true, '', 'Bytes') == false)
		return false;

	myObj = document.getElementById ('txtTrmPwrGain');
	if (numericValueRangeCheck (myObj, '', '', -30, 5, true, '', 'dbm') == false)
		return false;

	myObj = document.getElementById ('txtShortRetryLmit');
	if (numericValueRangeCheck (myObj, '', '', 0, 128, true, '', '') == false)
		return false;

	myObj = document.getElementById ('txtLongRetryLmit');
	if (numericValueRangeCheck (myObj, '', '', 0, 128, true, '', '') == false)
		return false;
		
    return true;
	}
