/* staticRouting.js - API library for static routes */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,23FEB11,mvb  Modified fun staticRoutesValidate()
     added new fun checkInterfaceSubnet().
01a,29SEP10,mvb  written. 
*/

function checkInterfaceSubnet ()
    {
    var intIPId = "";
    var intIPMaskId = "";
    var intPToPAddrId = "";
    var selectedInt = document.getElementById ('selInterface').value;
    if (selectedInt == "DMZ")
        {
        intIPId = "hdDmzIPAddr";
        intIPMaskId = "hdDmzSnetAddr";
        }
    else if (selectedInt == "WAN1")
        {
        intIPId = "hdWan1IPAddr";
        intIPMaskId = "hdWan1SnetAddr";
        intPToPAddrId = "hdWan1PToPAddr";
        }
    else if (selectedInt == "WAN2")
        {
        intIPId = "hdWan2IPAddr";
        intIPMaskId = "hdWan2SnetAddr";
        intPToPAddrId = "hdWan2PToPAddr";
        }
    else if (selectedInt == "WAN3")
        {
        intIPId = "hdWan3IPAddr";
        intIPMaskId = "hdWan3SnetAddr";
        intPToPAddrId = "hdWan3PToPAddr";
        }
    else if (selectedInt == "WAN4")
        {
        intIPId = "hdWan4IPAddr";
        intIPMaskId = "hdWan4SnetAddr";
        intPToPAddrId = "hdWan4PToPAddr";
        }
    else
        {
        intIPId = "hdLanIPAddr"+selectedInt;
        intIPMaskId = "hdLanSnetAddr"+selectedInt;
        }
    if (document.getElementById(intIPId) && document.getElementById(intIPMaskId))
        {
        if (document.getElementById(intIPId).value == "" ||
            document.getElementById(intIPId).value == "0.0.0.0" ||
            document.getElementById(intIPMaskId).value == "" ||
            document.getElementById(intIPMaskId).value == "0.0.0.0")
            {
            var errorstr = "Selected interface does not have a valid ip address"
            if (document.getElementById('selInterfaceErr'))
                document.getElementById('selInterfaceErr').innerHTML = errorstr
            else
                alert (errorstr)
            return false;
            }
        }
    
    var gwIp = getIPInt('tblStaticGwAddr')
    var intIp = getIPInt1(intIPId);
    var intIpMask = getIPInt1(intIPMaskId);
    
    var gwIpStr = getIPStr('tblStaticGwAddr')
    var intIpStr = getIPStr1(intIPId);
    var intIpMaskStr = getIPStr1(intIPMaskId);
    var intSubnetStr = intIpStr + "/" + intIpMaskStr;
    // Check for P-T-P Links
    var PToPLinkObj = document.getElementById(intPToPAddrId);
    if (document.getElementById(intIPMaskId).value == "255.255.255.255" &&
        PToPLinkObj && PToPLinkObj.value != "" && PToPLinkObj.value != "0.0.0.0")
        {
        var ptopIp = getIPInt1(intPToPAddrId);
        if (gwIp != intIp && gwIp != ptopIp)
            {
            var message1="Gateway IP Address must be in the subnet:";
            var errorstr =message1 + intSubnetStr;
            alert (errorstr);
            return false;
            }
        }
    else if (isInSubnet(gwIp, intIp, intIpMask)) {
    } else {
        var errorstr = "Gateway IP Address must be in Selected Interface Subnet:" + intSubnetStr;
        if (document.getElementById('txtGwIpAddrErr'))
            document.getElementById('txtGwIpAddrErr').innerHTML = errorstr
        else
            alert (errorstr)
        return false;
        }
    return true;
    }

function staticRoutesValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid name for the static route to be added';
    var errMsgL10n2 = 'Invalid Destination IP address.';
    var errMsgL10n3 = 'for octet';
    var errMsgL10n4 = 'Invalid IP subnet mask.';
    var errMsgL10n5 = 'Invalid Gateway IP address.';
    var errMsgL10n6 = 'Invalid metric value: Please enter a value between 2 and 15.'
    var errMsgL10n7 = 'Invalid metric value.';
     /* L10N Error Message Collection End */ 
    var flag = 0;
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtStaticRouteName," +
                      errMsgL10n1;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if (isProblemCharArrayCheck2 (txtFieldIdArr) == false)
         return false;
         
    if (ipv4AddrOctetsValidate ('tblStaticDstIpAddr', 'NID', false, true,
             errMsgL10n2,errMsgL10n3, true) == false)
        return false;
    var smObj = document.getElementById('tblStaticSubnetMask').getElementsByTagName("INPUT");
    for(i=0; i < smObj.length; i++)
        {
        if(smObj[i].value!= "0") { flag = 1; }
        }
    if(flag == 1)
        {
        if (ipv4AddrOctetsValidate ('tblStaticSubnetMask', 'SNM', false, true,
             errMsgL10n4, errMsgL10n3, true) == false)
            return false;
        
        if (subnetValidate ('tblStaticDstIpAddr', 'tblStaticSubnetMask') == false)
            return false;
        }
    if (ipv4AddrOctetsValidate ('tblStaticGwAddr', 'IPD', false, true,
             errMsgL10n5, errMsgL10n3, true) == false)
        return false;
    var metricObj = document.getElementById('txtStaticRouteMetric');
    if (metricObj && !metricObj .disabled)
        {
        if (numericValueRangeCheck (metricObj , 1, 
                                    errMsgL10n6,
                                    2, 15, true, errMsgL10n7, "") == false)
            return false;
        }
    
    if (checkInterfaceSubnet () == false)
        return false;
    
    return true;
	}
